

#ifndef Asagent_includeD
#define Asagent_includeD Yes

#include "../s_tools/sfile.h"

typedef char Asagent_helplinE[81];

/*
*/

struct AsagenT {

 /* Name of the program which is using this agent */
 char progname[SfileadrL];

 /* interface to supervising application */
 char *app;                                            /* should be (void *) */
 int (*App_interpreter) ();                   /* (*app, char *cmd, int flag) */
 int (*App_eval) ();               /* (*app, char *in, char **out, int flag) */
 int (*App_determine_current) ();          /* (*app, char **adrpt,int *idx,  */
                                           /*        int *count,   int flag) */
 int (*App_cursor_advance) ();                /* (*app, int *step, int flag) */
 int (*App_seems_known) (); /* (*app, char *adr, int *filec, char ***filev,
                                                                   int flag) */

 int service_mode;           /* indicates the type of service provided
                                 0= server mode, working for application
                                 1= client mode, finally connected to a server
                              */
 int data_mode;
 struct SconN *client_sconn;
 int server_crucial;
 int preclient_disable_internal;
 int loop_return_on_idle;

 int encapsulate_views;
 int input_fd;
 int override_event_fd;
 int request_mode;
 struct LstrinG *current_users;

 struct LstrinG *markstack;   /* keeps track of server's open marks */
 char *notified_mark_id;      /* stores id of outermost mark notification
                                 received by client */
 int notified_mark_fd;
 char *notified_reply_id;     /* id of outermost reply notification */

 /* state informations about the remote application */
 int remote_idx;
 int remote_count;
 char *remote_adr;

 int silent_end;             /* 1= do not print messages on end */

 int end_on_flag;            /* end program on several triggers
                                 bit0= end of list reached
                                 bit1= prompt encountered in client mode
                                 bit2= timeout
                                 bit3= idle
                                 bit4= mark
                              */
 int end_on_timeout;
 int end_on_idle;
 char *end_on_mark;

 int recursion_level;        /* counts recursions of Asagent_interpreter() */
 int recursion_max;          /* to prevent endless recursion */

 char start_dir[SfileadrL];
 int arguments_to_queue;
 int permission_check;

 struct SaccesS  *access;
 struct AsqueuE *queue;
 struct AsevenT *event;
 int stdout_pipe[2];
 int stderr_pipe[2];

 struct AsviewprotO *view_prototype;
 struct AsvieW *views;
 int view_counter;
 int ask_counter;

 int disable_internal; /*
                                bit0= current_file
                                bit1= double_files
                                bit2= stdout
                                bit3= stderr
                                bit16= stdin/termios from terminal
                              */
 struct AsvieW *internal_current_view;
 int repair_icv;
 int repair_icv_idx;         /* index of last repaired file */

 int look_for_doubles; /* 0=never , 1=if not already guarded , 2=always */
 int doubles_shown;

 char *maindir;
 char *trashdir;

 int keep_views;
 int no_keep_views_when_idle;
 struct AsrM *deferred_rm_jobs;

 struct AsviewmsG *viewmsg;

 int smem_stderr; /* debugging:  messages about development of memory usage */
};


#define Asagent_viewer_cmD "display"



#endif /* ! Asagent_includeD */

