
#include "../s_tools/sfile.h"

#ifndef Asview_includeD
#define Asview_includeD Yes

#define Asview_id_strL 256


struct AsviewsubscR {

 char type[Asview_id_strL];
 char class[Asview_id_strL];
 char representation[Asview_id_strL];

/*
   Type              Class     Representations    Fields    
 ----------------------------------------------------------------------
   init              ctrl      data               id
   end               ctrl      -                  -
   prompt            text      data               idx count
   prompt            text      -                  -      (this is unprompting)
   stdout            text      data               text
   stderr            text      data               text
   current_file      imgfile   address | data     [file1[content1]]
   double_files      imgfile   address | data     [file1[content1]
                                                  [... fileN[contentN]]]
   current_file_copy imgfile   address            [file1]
   double_files_copy imgfile   address            [file1 [... fileN]]
   ask               input     data               id type text constraint
                                                  (type= line|char|cancel)
 ----------------------------------------------------------------------
 Class ctrl is delivered even if not subscribed
*/

 struct AsviewsubscR *next;
};


struct AsviewprotO {

 char *cmd;
 char *geometry_option;
 char *geometry_left;
 char *geometry_right;

};



struct AsvieW {

 struct AsagenT *agent;

 char id[Asview_id_strL];       /* individual name of view */

 char type[Asview_id_strL];
                   /* 
                       child ... a AsviewprotO process started by the program
                                 and to be ended by the program
                       pipe ... connected to a SconN

                       copy ... copy file(s) to target filename and notify
                                via SconN
                    */  
 int broken;

 int encapsulated;
 int keep_copy_time;

 char **files;
 int filecount;
 int index;

 struct LstrinG *shown_purposes;

 struct AsviewsubscR *subscriptions;


 /* type 'child' : viewer is a process started by imv */

 struct AsviewprotO *proto;
 int pos;                            /* 0= upper left , 1= upper right */

 pid_t pid;
 int pid_valid;


 /* type 'pipe' : send messages into SconN */
 /* message format :
     type number_of_fields [field[...field]]\n
    field format
      :name:representation:number_of_bytes:bytes
    possible values of type and representation: see above
 */

 struct SconN *sconn;


 /* type 'copy' : copy file(s) to target filename and notify via SconN */
 char *copy_target;
 int copy_limit;
 unsigned long copy_counter;

 struct AsvieW *next,*prev;

};


#endif /* ! Asview_includeD */
